"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("./util");
var native = require("./native");
/**
 * Version of the swc binding.
 */
exports.version = require("./package.json").version;
function plugins(ps) {
    return function (mod) {
        var m = mod;
        for (var _i = 0, ps_1 = ps; _i < ps_1.length; _i++) {
            var p = ps_1[_i];
            m = p(m);
        }
        return m;
    };
}
exports.plugins = plugins;
var Compiler = /** @class */ (function (_super) {
    __extends(Compiler, _super);
    function Compiler() {
        return _super.call(this) || this;
    }
    Compiler.prototype.parse = function (src, options) {
        var _this = this;
        options = options || { syntax: "ecmascript" };
        options.syntax = options.syntax || "ecmascript";
        return new Promise(function (resolve, reject) {
            _super.prototype.parse.call(_this, src, options, function (err, value) {
                if (!!err)
                    return reject(err);
                resolve(JSON.parse(value));
            });
        });
    };
    Compiler.prototype.parseSync = function (src, options) {
        options = options || { syntax: "ecmascript" };
        options.syntax = options.syntax || "ecmascript";
        return JSON.parse(_super.prototype.parseSync.call(this, src, options));
    };
    Compiler.prototype.parseFile = function (path, options) {
        var _this = this;
        options = options || { syntax: "ecmascript" };
        options.syntax = options.syntax || "ecmascript";
        return new Promise(function (resolve, reject) {
            _super.prototype.parseFile.call(_this, path, options, function (err, value) {
                if (!!err)
                    return reject(err);
                resolve(JSON.parse(value));
            });
        });
    };
    Compiler.prototype.parseFileSync = function (path, options) {
        options = options || { syntax: "ecmascript" };
        options.syntax = options.syntax || "ecmascript";
        return JSON.parse(_super.prototype.parseFileSync.call(this, path, options));
    };
    /**
     * Note: this method should be invoked on the compiler instance used
     *  for `parse()` / `parseSync()`.
     */
    Compiler.prototype.print = function (m, options) {
        var _this = this;
        options = options || {};
        return new Promise(function (resolve, reject) {
            _super.prototype.print.call(_this, JSON.stringify(m), options, function (err, value) {
                if (!!err)
                    return reject(err);
                resolve(value);
            });
        });
    };
    /**
     * Note: this method should be invoked on the compiler instance used
     *  for `parse()` / `parseSync()`.
     */
    Compiler.prototype.printSync = function (m, options) {
        options = options || {};
        return _super.prototype.printSync.call(this, JSON.stringify(m), options);
    };
    Compiler.prototype.transform = function (src, options) {
        return __awaiter(this, void 0, void 0, function () {
            var isModule, plugin, m, _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        isModule = typeof src !== "string";
                        options = options || {};
                        options.jsc = options.jsc || {};
                        plugin = options.plugin;
                        delete options.plugin;
                        if (!plugin) return [3 /*break*/, 4];
                        if (!(typeof src === "string")) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.parse(src, options.jsc.parser)];
                    case 1:
                        _a = _b.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        _a = src;
                        _b.label = 3;
                    case 3:
                        m = _a;
                        return [2 /*return*/, this.transform(plugin(m), options)];
                    case 4: return [2 /*return*/, new Promise(function (resolve, reject) {
                            _super.prototype.transform.call(_this, isModule ? JSON.stringify(src) : src, isModule, options, function (err, value) {
                                if (!!err)
                                    return reject(err);
                                resolve(value);
                            });
                        })];
                }
            });
        });
    };
    Compiler.prototype.transformSync = function (src, options) {
        var isModule = typeof src !== "string";
        options = options || {};
        options.jsc = options.jsc || {};
        var plugin = options.plugin;
        delete options.plugin;
        if (plugin) {
            var m = typeof src === "string" ? this.parseSync(src, options.jsc.parser) : src;
            return this.transformSync(plugin(m), options);
        }
        return _super.prototype.transformSync.call(this, isModule ? JSON.stringify(src) : src, isModule, options);
    };
    Compiler.prototype.transformFile = function (path, options) {
        return __awaiter(this, void 0, void 0, function () {
            var plugin, m;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options = options || {};
                        options.jsc = options.jsc || {};
                        plugin = options.plugin;
                        delete options.plugin;
                        if (!plugin) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.parseFile(path, options.jsc.parser)];
                    case 1:
                        m = _a.sent();
                        return [2 /*return*/, this.transform(plugin(m), options)];
                    case 2: return [2 /*return*/, new Promise(function (resolve, reject) {
                            _super.prototype.transformFile.call(_this, path, 
                            /* isModule */ false, options, function (err, value) {
                                if (!!err)
                                    return reject(err);
                                resolve(value);
                            });
                        })];
                }
            });
        });
    };
    Compiler.prototype.transformFileSync = function (path, options) {
        options = options || {};
        options.jsc = options.jsc || {};
        var plugin = options.plugin;
        delete options.plugin;
        if (plugin) {
            var m = this.parseFileSync(path, options.jsc.parser);
            return this.transformSync(plugin(m), options);
        }
        return _super.prototype.transformFileSync.call(this, path, /* isModule */ false, options);
    };
    return Compiler;
}(util_1.wrapNativeSuper(native.Compiler)));
exports.Compiler = Compiler;
var compiler = new Compiler();
function parse(src, options) {
    return compiler.parse(src, options);
}
exports.parse = parse;
function parseSync(src, options) {
    return compiler.parseSync(src, options);
}
exports.parseSync = parseSync;
function parseFile(path, options) {
    return compiler.parseFile(path, options);
}
exports.parseFile = parseFile;
function parseFileSync(path, options) {
    return compiler.parseFileSync(path, options);
}
exports.parseFileSync = parseFileSync;
function print(m, options) {
    return compiler.print(m, options);
}
exports.print = print;
function printSync(m, options) {
    return compiler.printSync(m, options);
}
exports.printSync = printSync;
function transform(src, options) {
    return compiler.transform(src, options);
}
exports.transform = transform;
function transformSync(src, options) {
    return compiler.transformSync(src, options);
}
exports.transformSync = transformSync;
function transformFile(path, options) {
    return compiler.transformFile(path, options);
}
exports.transformFile = transformFile;
function transformFileSync(path, options) {
    return compiler.transformFileSync(path, options);
}
exports.transformFileSync = transformFileSync;
exports.DEFAULT_EXTENSIONS = Object.freeze([
    ".js",
    ".jsx",
    ".es6",
    ".es",
    ".mjs",
    ".ts",
    ".tsx"
]);
